Frog Jump

A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.

Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.

If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.

Note:

  • The number of stones is ≥ 2 and is < 1,100.
  • Each stone's position will be a non-negative integer < 231.
  • The first stone's position is always 0.

Example 1:

[0,1,3,5,6,8,12,17]

There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit. Return true. The frog can jump to the last stone by jumping
1 unit to the 2nd stone, then 2 units to the 3rd stone, then
2 units to the 4th stone, then 3 units to the 6th stone,
4 units to the 7th stone, and 5 units to the 8th stone.

Example 2:

[0,1,2,3,4,8,9,11]

Return false. There is no way to jump to the last stone as
the gap between the 5th and 6th stone is too large. 分析:
暴力解法:
首先要明白,不是所有的石头都必须要跳上去,题目没有说清楚,上面的例子也很misleading. 暴力解法很简单,从当前点(石头)和跳到当前点的步数,看后面是否有石头可以reach,如果可以,以那个新的石头和新的步数继续递归,如果我们reach到最后一个石头,return true.
 public class Solution {

     public boolean canCross(int[] stones) {

         if (stones == null || stones.length == ) return true;
if (stones[] - stones[] != ) return false; return isPossible(stones, , );
} public boolean isPossible(int[] stones, int start, int jumps) {
if (start == stones.length - )
return true;
for (int i = start + ; i < stones.length; i++) {
int diff = stones[i] - stones[start];
if (diff <= jumps + && diff >= jumps - ) {
if (isPossible(stones, i, diff)) {
return true;
}
}
}
return false;
}
}

方法二:保存跳到某个点的时候的步数,这样,只要最后一个点有步数,我们就可以保证那个点能够被跳到。

 public class Solution {
public boolean canCross(int[] stones) {
if (stones == null || stones.length == ) return false;
// Map<position, the # of jumps the frog takes to reach this position>
Map<Integer, Set<Integer>> map = new HashMap<>(); for (int position : stones) {
map.put(position, new HashSet<Integer>());
}
// in order to avoid checking whether the first jump is at position 0 or not,
// we set the # of jumps the frog takes to the first position is 0.
map.get().add(); for (int position : stones) {
for (Integer steps : map.get(position)) {
if (map.containsKey(position + steps - ) && steps - > ) {
map.get(position + steps - ).add(steps - );
} if (map.containsKey(position + steps) && steps > ) {
map.get(position + steps).add(steps);
} if (map.containsKey(position + steps + )) {
map.get(position + steps + ).add(steps + );
}
}
}
return map.get(stones[stones.length - ]).size() != ;
}
}
上一篇:HDU 4417 - Super Mario ( 划分树+二分 / 树状数组+离线处理+离散化)


下一篇:BZOJ-3229 石子合并 GarsiaWachs算法